
//****************************RADIO_FM_DIGITAL********************************//
////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
//****************************************************************************//
//****** MCU:PIC16f887                                                 *******//
//****** Clock_Frecuency:8Mhz                                          *******//
//****** SCL:18 SDA:23                                                 *******//
//****************************************************************************//
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////
#include "built_in.h"
#define TEA5767_W 0xC0
/////////////////////////LCD_declarations///////////////////////////////////////
sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;
////////////////////////////////////////////////////////////////////////////////
float Freq=98.9;
char txt[5];
short int est0=1, est1=1;
////////////////////////////////////////////////////////////////////////////////
void Set_up() {

  ANSEL = 0;
  ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  trisc.b3=1;
  trisc.b4=1;
  TRISD0_bit=1;
  TRISD1_bit=1;
  I2C1_Init(100000);
  Delay_ms(200);
  Lcd_Init();
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Cmd(_LCD_CURSOR_OFF);
  Lcd_Out(1, 2, "RADIO_FM");
  Lcd_Out(2, 10, "MHZ");
  Delay_ms(10);
}
////////////////////////////////////////////////////////////////////////////////
void tea5767_setFrequency(double frequency)
{
  unsigned char frequencyH=0;
  unsigned char frequencyL=0;
  unsigned int frequencyB;

  frequencyB=4*(frequency*1000000+225000)/32768;
  frequencyH=frequencyB>>8;
  frequencyL=frequencyB&0XFF;

  i2c1_Start();
  i2c1_Wr(TEA5767_W);
  i2c1_Wr(frequencyH);
  i2c1_Wr(frequencyL);
  i2c1_Wr(0xB0);
  i2c1_Wr(0x10);
  i2c1_Wr(0x00);
  i2c1_Stop();
  Delay_ms(10);
}
////////////////////////////////////////////////////////////////////////////////
void FREQ_FM() {

    FloatToStr(Freq, txt);
    txt[5] = 0;
    if(Freq<100)Lcd_Out(2,4,txt), Lcd_Chr(2,8,' ');
    else Lcd_Out(2,4,txt);
    Delay_ms(10);
}
////////////////////////////////////////////////////////////////////////////////
void main() {
Set_up();
tea5767_setFrequency(freq);
FREQ_FM();
 do {
   if (Button(&PORTD,1,5,0)) est0=0;      //if the button has been pushed
   if (est0==0 && Button(&PORTD,1,5,1)){  //and after that the button is free
       Freq=Freq+0.1;                         //increase Freq.
   if (Freq>108.0) Freq=88.0;
      tea5767_setFrequency(Freq);
      FREQ_FM();
      est0=1;
   }
   if (Button(&PORTD,0,5,0)) est1=0;      //if the button has been pushed
   if (est1==0 && Button(&PORTD,0,5,1)){  //and after that the button is free
       Freq=Freq-0.1;                         //decrease Freq.
   if (Freq<88.0) Freq=108.0;
       tea5767_setFrequency(Freq);
       FREQ_FM();
       est1=1;
   }
   if (Button(&PORTD,0,300,0) && Button(&PORTD,1,300,0)){  //Fast mode
      Freq=Freq+1.0;
      if (Freq>108.0) Freq=88.0;
      tea5767_setFrequency(Freq);
      FREQ_FM();
   }
 } while (1);
}
////////////////////////////////////////////////////////////////////////////////